#ifndef _RandomBox
#define _RandomBox

#include<vector>
#include<random>
#include<string>

using namespace std;

///<summary>ٸ   ϰ  븸 ִ Դϴ.</summary>
class ContentViewer
{
public:
    string name;
    float rate;
    unsigned int number;
    unsigned int pickedTime;
    bool isInfinity;
    bool isFlexible;
};

class Content;

/// <summary≯ ϰ, ۿ ִ ڷᱸԴϴ.</summary>
class TrieNode
{
private:
    /// <summary> ġ Ÿ ڸ ݴϴ.</summary>
    char character;
    /// <summary> ġ Ǿ ִ  ݴϴ.</summary>
    Content* address;

    /// <summary> ġ   ġ ݴϴ.</summary>
    TrieNode* parent;
    /// <summary> ġ   ġ ݴϴ.</summary>
    vector<TrieNode*> childList;

public:
    TrieNode(){}

    TrieNode(char wantCharacter)
    {
        address = nullptr;
        parent = nullptr;
        character = wantCharacter;
    }

    /// <summary>ϴ ڰ Ǿִ Ȯմϴ.</summary>
    TrieNode* CheckChild(char targetCharacter);

    /// <summary>ش ڿ ڷᱸ ߰մϴ.</summary>
    void Insert(string wantString, Content* wantAddress);

    /// <summary>ش ڷᱸ   иŵϴ.</summary>
    void Destroy();

    /// <summary>ش ڿ ڷᱸ մϴ.</summary>
    void Delete();

    /// <summary>ڿ ޾Ƽ شϴ ġ ãϴ.</summary>
    Content* Find(string wantString);
};

///<summary>ڽ  Դϴ.</summary>
class Content
{
public:
    ///<summary>ش  Ű Trie带 Ÿϴ.</summary>
    TrieNode* inTrie;

private:
    ///<summary>ش   Ÿϴ.</summary>
    Content* next;
    ///<summary>ش  ľ Ÿϴ.</summary>
    Content* prev;

    ///<summary>ش  ̸Դϴ.</summary>
    string name;
    ///<summary>ش  ȮԴϴ.</summary>
    float rate;
    ///<summary>ش  Դϴ.</summary>
    unsigned int number;

    ///<summary>ش     Ÿϴ.</summary>
    unsigned int pickedTime;

    ///<summary>ش     ִ Ÿϴ.</summary>
    bool isInfinity;

public:
    ///<summary>ش  Ȯ Ÿϴ.</summary>
    bool isFlexible;
    ///<summary>ش  ȰȭǾִ Ÿϴ.</summary>
    bool isAvailable;

    ///<summary≯ Ȯ, ɼ    ִ  ϴ.</summary>
    Content(string wantName, float wantRate, bool wantFlexible)
    {
        inTrie = nullptr;

        next = nullptr;
        prev = nullptr;

        name = wantName;
        rate = wantRate;
        number = 0;

        pickedTime = 0;

        isInfinity = true;
        isFlexible = wantFlexible;
        isAvailable = true;
    };

    ///<summary≯ Ȯ, , ɼ ϴ ŭ   ִ  ϴ.</summary>
    Content(string wantName, float wantRate, unsigned int wantNumber, bool wantFlexible)
    {
        inTrie = nullptr;

        next = nullptr;
        prev = nullptr;

        name = wantName;
        rate = wantRate;
        number = wantNumber;

        pickedTime = 0;

        isInfinity = false;
        isFlexible = wantFlexible;
        isAvailable = true;
    };

    ~Content()
    {
        if (inTrie != nullptr)
        {
            inTrie->Delete();
        };
        Pop();
    };

    ///<summary>    ִ  Ȯմϴ.</summary>
    bool AvailableCheck()
    {
        //ȰȭǾ   ϴ.
        if (!isAvailable)
        {
            return false;
        }
        //̶   ֽϴ.
        else if (isInfinity)
        {
            return true;
        }
        //    ֽϴ.
        else if (number > 0)
        {
            return true;
        }
        // ƴϰ   ʾҴٸ   ϴ.
        else
        {
            return false;
        };
    };

    ///<summary>Ȯ Ȯ    ִ Ȯմϴ.  شϴ ̶,   ̰  ȯմϴ.</summary>
    ///<param name="rateIn"> Ȯ ⿡ ֽϴ.</param>
    ///<param name="rateOut">    Ȯ ȯϴ Դϴ.</param>
    ///<param name="multiplier">Ȯ  ϴ Դϴ. ۿ ش  ؼ  Ȯ ϰ մϴ.</param>
    Content* RateCheck(float* rate, float multiplier);

    ///<summary>  ϴ  ο ֽϴ.</summary>
    Content* Insert(Content* targetRoot);

    ///<summary>  մϴ.</summary>
    Content* Delete(Content* targetRoot)
    {
        //   ϴ.
        if (prev != nullptr)
        {
            prev->next = next;
            prev = nullptr;
        }
        // 尡 ٸ,  ù ° ҿǷ,  尡 ù ° ˸ϴ.
        else
        {
            targetRoot = next;
        };

        //   ϴ.
        if (next != nullptr)
        {
            next->prev = prev;
            next = nullptr;
        };

        return targetRoot;
    };

    /// <summary>   ϴ.</summary>
    void Destroy()
    {
        if (this != nullptr)
        {
            prev = nullptr;
            if (next != nullptr)
            {
                next->Destroy();
                next = nullptr;
            };
            inTrie = nullptr;
            free(this);
        };
    }


private:
    /// <summary>,    ϴ.</summary>
    void Pop()
    {
        if (next != nullptr)
        {
            next->prev = prev;
            next = nullptr;
        };
        if (prev != nullptr)
        {
            prev->next = next;
            prev = nullptr;
        };
    }

    /// <summary>ش  ڷ ̵մϴ.</summary>
    void MoveAfter(Content* targetContent);

    /// <summary>ش   ̵մϴ.</summary>
    void MoveBefore(Content* targetContent);

    /// <summary> ߰մϴ.</summary>
public:
    void AddNumber(unsigned int wantNumber);

    /// <summary> ҽŵϴ.</summary>
    void SubNumber(unsigned int wantNumber);

    /// <summary> մϴ.</summary>
    void SetNumber(unsigned int wantNumber)
    {
        number = wantNumber;
    };

    /// <summary>   ִ մϴ.</summary>
    void SetInfinity(bool wantInfinity)
    {
        isInfinity = wantInfinity;
    };

    /// <summary≯ մϴ.</summary>
    void SetName(string wantName, TrieNode* targetRootTrie)
    {
        //ٲ ̸  ̸ ٸ 쿡 մϴ.
        if (name != wantName)
        {
            //  ̸ Trie ڷᱸ մϴ.
            inTrie->Delete();

            //  ̸ Trie ڷᱸ ߰մϴ.
            targetRootTrie->Insert(wantName, this);

            //̸  մϴ.
            name = wantName;
        };
    };

    /// <summary>Ȯ մϴ.</summary>
    Content* SetRate(float wantRate, Content* targetRoot);

    /// <summary>  Ȯմϴ.</summary>
    unsigned int GetNumber()
    {
        return number;
    }

    /// <summary> ̸ Ȯմϴ.</summary>
    string GetName()
    {
        return name;
    }

    /// <summary>  Ȯմϴ.</summary>
    bool GetInfinity()
    {
        return isInfinity;
    }

    /// <summary> Ȯ Ȯմϴ.</summary>
    float GetRate()
    {
        return rate;
    }

    /// <summary>  ڿ ̾  Ȯ ݴϴ.</summary>
    float GetTotalRate();

    /// <summary> 带 ȯմϴ.</summary>
    Content* GetNext()
    {
        return next;
    }

    /// <summary> 带 ȯմϴ.</summary>
    Content* GetPrev()
    {
        return prev;
    }

    /// <summary>    ο  ϴ.</summary>
    ContentViewer GetViewer()
    {
        ContentViewer returnViewer;

        returnViewer.isFlexible = isFlexible;
        returnViewer.isInfinity = isInfinity;
        returnViewer.name = name;
        returnViewer.number = number;
        returnViewer.rate = rate;
        returnViewer.pickedTime = pickedTime;

        return returnViewer;
    }

    /// <summary>  ڿ   带 ִ  Ʈ · ȯմϴ.</summary>
    vector<ContentViewer> GetViewerAll()
    {
        vector<ContentViewer> returnList;

        returnList.push_back(GetViewer());

        Content* nextContent = next;
        while (nextContent != nullptr)
        {
            returnList.push_back(nextContent->GetViewer());
            nextContent = nextContent->next;
        };

        return returnList;
    }
};

class RandomBox
{
private:
    ///<summary≯ ˻  Trieڷᱸ ġԴϴ.</summary>
    TrieNode* rootTrie = nullptr;

    ///<summary>Ȯ    ù ° Դϴ.</summary>
    Content* rootFlexible = nullptr;
    ///<summary>εȮ    ù ° Դϴ.</summary>
    Content* rootNonFlexible = nullptr;

    ///<summary> Ȯ  ǥմϴ.</summary>
    float rateFlexible = 0.0f;
    ///<summary> εȮ  ǥմϴ.</summary>
    float rateNonFlexible = 0.0f;
    
public:
    ~RandomBox()
    {
        if (rootTrie != nullptr)
        {
            rootTrie->Destroy();
            rootTrie = nullptr;
        };

        if (rootFlexible != nullptr)
        {
            rootFlexible->Destroy();
            rootFlexible = nullptr;
        };
        
        if (rootNonFlexible != nullptr)
        {
            rootNonFlexible->Destroy();
            rootNonFlexible = nullptr;
        };
    };

    RandomBox()
    {
        rootTrie = new TrieNode();
    }

    ///<summary>ڽ  ̾ ڿ ȯմϴ.    nullptr ȯմϴ.</summary>
    string Pick();

    ///<summary>ϴ  ̸ ,      ȯմϴ.</summary>
    ContentViewer GetViewer(string name);

    ///<summary>/εȮ   ִ  Ʈ ȯմϴ.</summary>
    ///<param name="wantFlexible">true , false εȮ Ÿϴ.</param>
    vector<ContentViewer> GetViewerAll(bool wantFlexible);

    ///<summary>ϴ ̸  մϴ.</summary>
    void Delete(string name);

    ///<summary>ϴ  ̸, Ȯ, ɼ Ͽ մϴ.     ֽϴ.</summary>
    bool Insert(string name, float wantRate, bool wantFlexible);

    ///<summary>ϴ  ̸, Ȯ, , ɼ Ͽ մϴ.  ŭ   ֽϴ.</summary>
    bool Insert(string name, float wantRate, unsigned int wantNumber, bool wantFlexible);

    ///<summary>ϴ    ŵϴ.</summary>
    void NumberAdd(string name, unsigned int wantNumber);

    ///<summary>ϴ    ҽŵϴ.</summary>
    void NumberSub(string name, unsigned int wantNumber);

    ///<summary>ϴ   ϴ  մϴ.</summary>
    void SetNumber(string name, unsigned int wantNumber);

    ///<summary>ϴ     ִ մϴ.</summary>
    void SetInfinity(string name, bool wantInfinity);

    ///<summary>ϴ  ̸ from to մϴ.</summary>
    void SetName(string from, string to);

    ///<summary>ϴ  Ȯ մϴ.</summary>
    void SetRate(string name, float wantRate);

    ///<summary>ϴ   ɼ մϴ.</summary>
    void SetFlexible(string name, bool wantFlexible);

    ///<summary>ϴ  Ȱȭ θ մϴ.</summary>
    void SetAvailable(string name, bool wantAvailable);
};
#endif